<template>
    <div>
        <crumbs title="任务列表">
            <el-form :inline="true" class="demo-form-inline">
                <el-form-item label="任务名称：">
                    <el-input size="mini" v-model="filter.missionName" placeholder="任务名称"></el-input>
                </el-form-item>
                <el-form-item>
                    <el-button size="mini" @click="filterDatas">确认</el-button>
                </el-form-item>
            </el-form>
        </crumbs>
        <div class="contents">
            <el-table :data="list"
                      border
                      style="width: 100%">
                <el-table-column
                        type="index"
                        :index="indexMethod"
                        label="编号"
                        width="60">
                </el-table-column>
                <el-table-column
                        prop="missionName"
                        label="任务名称">
                </el-table-column>
                <el-table-column
                        label="操作" width="150">
                    <template slot-scope="scope"><el-button type="text" size="small" @click="toTaskDetail(scope.row.id)">详情</el-button>
                        <span style="margin:0 3px;">|</span>
                        <!--<el-button type="text" size="small" @click="toEditField(scope.row, 'modify')">修改</el-button>
                        <span style="margin:0 3px;">|</span>-->
                        <el-button type="text" size="small" class="delete" @click="showDelDialog(scope.row.id)">删除</el-button>
                    </template>
                </el-table-column>
            </el-table>
            <el-pagination :current-page.sync="currentPage"
                           @current-change="currentChange"
                           background
                           :page-size="pageSize"
                           :layout="pageLayout"
                           :total="total">
            </el-pagination>
        </div>
    </div>
</template>

<script>
  import api from '@api/qualityControl.js';
  import config from '@api/config.js';

  export default {
    name: 'AutoTestTask',
    data: function () {
      return {
        list: [],
        tagType:[1],
        currentPage: 1,
        pageSize: 10,
        total: 0,
        fieldTypes:[],
        searched:false,
        pageLayout:config.pageLayout,
        hisTypes:[],
        filter: {
          missionName: ''
        }
      }
    },
    created() {
      const _this=this;
      setTimeout(function() {
        _this.getDataList()
      },100);
    },
    watch:{
      'filter':{
        handler:function(){
          this.searched = false;
        },
        deep:true
      }
    },
    beforeRouteEnter(to, from, next){
      next(vm => {
        //const pm = to.param;
        Object.assign(vm,to.params);
        vm.inCurrentPage=to.params.currentPage;
      })
    },
    methods: {
      toTaskDetail(id){
        const pam = this.searched ? {
          currentPage: this.currentPage,
          filter: this.filter,
          id
        } : {currentPage: this.currentPage,id};
         this.$router.push({
           name:'TaskDetail',
           params: pam
         })
      },
      filterDatas(){
        this.currentPage = 1;
        this.getDataList();
      },
      getDataList() {
        const param = this.getFilterItems();
        this.searched = true;
        api.getTaskList(param).then((res) => {
          if (res.data.code == '0') {
            const data = res.data.data;
            this.list = data.records;
            this.total = data.total;
          }
        }).catch((error) => {
          console.log(error);
        });
      },
      getFilterItems() {
        const param = Object.assign({
          current: this.currentPage,
          size: this.pageSize,
        },this.filter);
        return param;
      },
      indexMethod(index) {
        return ((this.currentPage - 1) * this.pageSize) + index + 1;
      },
      currentChange(next) {
        this.currentPage = next;
        this.getDataList();
      },
      warning(msg,type){
        this.$message({
          showClose: true,
          message:msg,
          type:type||'warning'
        })
      },
      showConfirmDialog(msg,resolve){
        this.$alert(msg, '提示', {
          confirmButtonText: '确定',
          type: 'warning'
        }).then(() => {
          resolve();
        }).catch(() => {});
      },
      showDelDialog(id){
        this.showConfirmDialog('是否删除该任务？',()=>{
          api.delTask({id:id}).then((res)=>{
            if(res.data.code=='0'){
              this.warning(res.data.msg||'操作成功','success');
              this.getDataList();
            }else{
              this.warning(res.data.msg);
            }
          }).catch((error)=>{
            this.warning(error);
          })
        });
      }
    }
  }
</script>

<style lang="less">
    @import "../../less/admin.less";
    .delete{
        color: red !important;
    }
</style>